class Nodo {
  Object info;
  Nodo next;
  Nodo prev;
  Nodo(Object i, Nodo n, Nodo p) {
    info = i;
    next = n;
    prev =p;
  }
}

public class ListaDoppia {
 
  protected Nodo sentinella;
  
  public ListaDoppia() {
    sentinella = new Nodo(null,null,null); //importante! perche'?
    sentinella.next = sentinella;
    sentinella.prev = sentinella;
    //il campo info non e' significativo 
  }

  public boolean presente(Object o) {
    return trova(o)!=sentinella;
  }

  public void aggiungiPrima(Object nuovo, Object o) {
    //aggiunge nuovo prima di o se presente
    Nodo pos = trova(o);
    if (pos != sentinella) {
      Nodo aux = new Nodo(nuovo,pos,pos.prev);
      pos.prev.next = aux;
      pos.prev = aux;
    }
  }

  public void aggiungiInCoda(Object nuovo) {
    Nodo pos = sentinella;
    Nodo aux = new Nodo(nuovo,pos,pos.prev);
    pos.prev.next = aux;
    pos.prev = aux;
  }
  
  public void aggiungiDopo(Object nuovo, Object o) {
    //aggiunge nuovo dopo o se presente
    Nodo pos = trova(o);
    if (pos != sentinella) {
      Nodo aux = new Nodo(nuovo,pos.next,pos);
      pos.next.prev = aux;
      pos.next = aux;
    }
  }

  public void aggiungiInTesta(Object nuovo) {
    Nodo pos = sentinella;
    Nodo aux = new Nodo(nuovo,pos.next,pos);
    pos.next.prev = aux;
    pos.next = aux;
  }

  public void elimina(Object o) {
    Nodo pos = trova(o);
    if (pos!=sentinella) {
      pos.prev.next = pos.next;
      pos.next.prev = pos.prev;
    }
  }

  private Nodo trova(Object o) {
    Nodo l = sentinella.next;
    while (l!=sentinella) {
      if (l.info.equals(o)) return l;
      l = l.next;
    }
    return sentinella;
  }
  
  public String toString() {
    String ris = "";
    Nodo l = sentinella.next;
    while (l!=sentinella) {
      ris = ris + l.info.toString();
      l = l.next;
    }
    return ris;
  }
    
}    
